﻿using System;
using System.Threading;
using Styx;
using Styx.Common;
using Styx.Helpers;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.Plugins;
using Styx.CommonBot;
using Styx.Common.Helpers;

namespace DamnYouShamanHEAL
{
    public class DYSH : HBPlugin
    {

        //Configuration
        public int HealAtPercentageWhenNoCombat = 65; //The percentage at we are going to heal out of combat
        public int HealAtPercentage = 40; //The percentage at we are going to heal.
        public int Spell = 8004; //The spell that is going to be cast.
        public bool UseThunderstorm = true; //(Elemental ONLY if you are not elemental just ignore) Want to use thunderstorm before healing (Only usefull without the Glyph of Thunderstorm)
        public bool HealWhenMounted = true; //If you are mounted, do you want to heal?
        public bool DebugMode = false; //Used for debugging... Not needed for the public.



        public override string Name { get { return "Darn You Shaman Heal!"; } }
        public override string Author { get { return "Thunderofnl"; } }
        public override Version Version { get { return new Version(1, 1, 0, 0); } }
        public static LocalPlayer Me = StyxWoW.Me;
        private readonly WaitTimer _updateTimer = WaitTimer.OneSecond;

        public DYSH()
        {
            Logging.Write("Darn You Shaman Heal! - Loaded");

        }

        public override void Pulse()
        {
            if (_updateTimer.IsFinished)
            {
                _updateTimer.Reset();
                if (DebugMode)
                {
                    Logging.Write("Debug: " + Convert.ToInt32(Me.HealthPercent));
                    Logging.Write("Debug: " + Convert.ToInt32(Me.Specialization));
                }

                if (!Me.IsDead)
                {
                    if (!Me.Mounted || HealWhenMounted)
                    {
                        int Healthpercentage = Convert.ToInt32(Me.HealthPercent);
                        if (Me.Class.ToString() == "Shaman")
                        {
                            if (!Me.IsActuallyInCombat)
                            {
                                if (Healthpercentage <= HealAtPercentageWhenNoCombat)
                                {
                                    //WoWMovement.MoveStop();
                                    SpellManager.Cast(Spell);
                                    Thread.Sleep(1500);
                                }
                            }
                            if (Healthpercentage <= HealAtPercentage)
                            {
                                if (Me.Specialization == WoWSpec.ShamanElemental)
                                {
                                    if (UseThunderstorm)
                                    {
                                        if (Me.IsActuallyInCombat)
                                        {
                                            if (Me.IsCasting)
                                            {
                                                Thread.Sleep(1500);
                                            }
                                            SpellManager.Cast(51490);

                                            Thread.Sleep(1000);
                                        }
                                    }
                                }

                                SpellManager.Cast(Spell);
                            }
                        }
                        else
                        {
                            _updateTimer.Stop();
                        }
                    }
                }
            }
        }

    }
}